Classic Dynamic Programming III

Ideal problem for Dynamic Programming: max/min problem, with an exponential complexity if executed thru brute-force. Given the number k and the string s, what you're going to do is keep track of the longest strings thus far ending on 'a', and 'b', and 'c', and, ..., and 'z'. Knowing the longest for the step i, it is easy to compute the best for the step i+1 by scanning the k previous solutions. Execution time becomes O(k*|s|) and space O(k). Since k is very small and finite, the practical execution time is linear and space is constant. Code is down below, cheers, ACC.

Longest Ideal Subsequence - LeetCode

2370. Longest Ideal Subsequence
Medium

You are given a string s consisting of lowercase letters and an integer k. We call a string t ideal if the following conditions are satisfied:

  • t is a subsequence of the string s.
  • The absolute difference in the alphabet order of every two adjacent letters in t is less than or equal to k.

Return the length of the longest ideal string.

subsequence is a string that can be derived from another string by deleting some or no characters without changing the order of the remaining characters.

Note that the alphabet order is not cyclic. For example, the absolute difference in the alphabet order of 'a' and 'z' is 25, not 1.

 

Example 1:

Input: s = "acfgbd", k = 2
Output: 4
Explanation: The longest ideal string is "acbd". The length of this string is 4, so 4 is returned.
Note that "acfgbd" is not ideal because 'c' and 'f' have a difference of 3 in alphabet order.

Example 2:

Input: s = "abcd", k = 3
Output: 4
Explanation: The longest ideal string is "abcd". The length of this string is 4, so 4 is returned.

 

Constraints:

  • 1 <= s.length <= 105
  • 0 <= k <= 25
  • s consists of lowercase English letters.
Accepted
10,086
Submissions
28,227

public int LongestIdealString(string s, int k)
{
    int[] longestEndingChar = new int[26];

    int retVal = 0;
    foreach (char c in s)
    {
        int tempVal = longestEndingChar[(int)(c - 'a')];
        for (int i = -k; i <= k; i++)
        {
            char temp = (char)((int)c + i);
            if (temp >= 'a' && temp <= 'z')
            {
                tempVal = Math.Max(tempVal, longestEndingChar[(int)(temp - 'a')] + 1);
                retVal = Math.Max(retVal, tempVal);
            }
        }
        longestEndingChar[(int)(c - 'a')] = tempVal;
    }

    return retVal;
}

Comments

Popular posts from this blog

Changing the root of a binary tree

ProjectEuler Problem 719 (some hints, but no spoilers)

The Power Sum, a recursive problem by HackerRank